Media Operations Use Case for an Extended Reality Application on Edge Computing Infrastructure
Internet-Draft draft-ietf-mops-ar-use-case-06
Renan Krishna
InterDigital Europe Limited
64, Great Eastern Street
London
EC2A 3QR
United Kingdom
renan.krishna@interdigital.com
Akbar Rahman
InterDigital Communications, LLC
1000 Sherbrooke Street West
Montreal
H3A 3G4
Canada
Akbar.Rahman@InterDigital.com
Operations and Management
MOPS
This document explores the issues involved in the use of Edge Computing resources to operationalize media use cases that involve Extended Reality (XR) applications. In particular, we discuss those applications that run on devices having different form factors and need Edge computing resources to mitigate the effect of problems such as a need to support interactive communication requiring low latency, limited battery power, and heat dissipation from those devices. The intended audience for this document are network operators who are interested in providing edge computing resources to operationalize the requirements of such applications. We discuss the expected behavior of XR applications which can be used to manage the traffic. In addition, we discuss the service requirements of XR applications to be able to run on the network.
Introduction
Extended Reality (XR) is a term that includes Augmented Realty (AR), Virtual Reality (VR) and Mixed Realty (MR) [XR]. AR combines the real and virtual, is interactive and is aligned to the physical world of the user [AUGMENTED_2]. On the other hand, VR places the user inside a virtual environment generated by a computer [AUGMENTED].MR merges the real and virtual world along a continuum that connects completely real environment at one end to a completely virtual environment at the other end. In this continuum, all combinations of the real and virtual are captured [AUGMENTED].
XR applications will bring several requirements for the network and the mobile devices running these applications. Some XR applications such as AR require a real-time processing of video streams to recognize specific objects. This is then used to overlay information on the video being displayed to the user. In addition XR applications such as AR and VR will also require generation of new video frames to be played to the user. Both the real-time processing of video streams and the generation of overlay information are computationally intensive tasks that generate heat [DEV_HEAT_1], [DEV_HEAT_2] and drain battery power [BATT_DRAIN] on the mobile device running the XR application. Consequently, in order to run applications with XR characteristics on mobile devices, computationally intensive tasks need to be offloaded to resources provided by Edge Computing.
Edge Computing is an emerging paradigm where computing resources and storage are made available in close network proximity at the edge of the Internet to mobile devices and sensors [EDGE_1], [EDGE_2]. These edge computing devices use cloud technologies that enable them to support offloaded XR applications. In particular, the edge devices deploy cloud computing implementation techniques such as disaggregation (breaking vertically integrated systems into independent components with open interfaces using SDN), virtualization (being able to run multiple independent copies of those components such as SDN Controller apps, Virtual Network Functions on a common hardware platform) and commoditization ( being able to elastically scale those virtual components across commodity hardware as the workload dictates) [EDGE_3]. Such techniques enable XR applications requiring low-latency and high bandwidth to be delivered by mini-clouds running on proximate edge devices
In this document, we discuss the issues involved when edge computing resources are offered by network operators to operationalize the requirements of XR applications running on devices with various form factors. Examples of such form factors include Head Mounted Displays (HMD) such as Optical-see through HMDs and video-see-through HMDs and Hand-held displays. Smart phones with video cameras and GPS are another example of such devices. These devices have limited battery capacity and dissipate heat when running. Besides as the user of these devices moves around as they run the XR application, the wireless latency and bandwidth available to the devices fluctuates and the communication link itself might fail. As a result algorithms such as those based on adaptive-bit-rate techniques that base their policy on heuristics or models of deployment perform sub-optimally in such dynamic environments[ABR_1]. In addition, network operators can expect that the parameters that characterize the expected behavior of XR applications are heavy-tailed. Such workloads require appropriate resource management policies to be used on the Edge. The service requirements of XR applications are also challenging when compared to the current video applications. In particular several QoE factors such as motion sickness are unique to XR applications and must be considered when operationalizing a network.
We motivate these issues with a use-case that we present in the following sections.
Conventions used in this document
The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT", "SHOULD", "SHOULD NOT", "RECOMMENDED", "MAY", and "OPTIONAL" in this document are to be interpreted as described in [RFC2119].
Use Case
We now describe a use case that involves an application with AR systems' characteristics. Consider a group of tourists who are being conducted in a tour around the historical site of the Tower of London. As they move around the site and within the historical buildings, they can watch and listen to historical scenes in 3D that are generated by the AR application and then overlaid by their AR headsets onto their real-world view. The headset then continuously updates their view as they move around.
The AR application first processes the scene that the walking tourist is watching in real-time and identifies objects that will be targeted for overlay of high resolution videos. It then generates high resolution 3D images of historical scenes related to the perspective of the tourist in real-time. These generated video images are then overlaid on the view of the real-world as seen by the tourist.
We now discuss this processing of scenes and generation of high resolution images in greater detail.
Processing of Scenes
The task of processing a scene can be broken down into a pipeline of three consecutive subtasks namely tracking, followed by an acquisition of a model of the real world, and finally registration [AUGMENTED].
Tracking: This includes tracking of the three dimensional coordinates and six dimensional pose (coordinates and orientation) of objects in the real world[AUGMENTED]. The AR application that runs on the mobile device needs to track the pose of the user's head, eyes and the objects that are in view.This requires tracking natural features that are then used in the next stage of the pipeline.
Acquisition of a model of the real world: The tracked natural features are used to develop an annotated point cloud based model that is then stored in a database.To ensure that this database can be scaled up,techniques such as combining a client side simultaneous tracking and mapping and a server-side localization are used[SLAM_1], [SLAM_2], [SLAM_3], [SLAM_4].
Registration: The coordinate systems, brightness, and color of virtual and real objects need to be aligned in a process called registration [REG]. Once the natural features are tracked as discussed above, virtual objects are geometrically aligned with those features by geometric registration .This is followed by resolving occlusion that can occur between virtual and the real objects [OCCL_1], [OCCL_2].
The AR application also applies photometric registration [PHOTO_REG] by aligning the brightness and color between the virtual and real objects.Additionally, algorithms that calculate global illumination of both the virtual and real objects [GLB_ILLUM_1], [GLB_ILLUM_2] are executed.Various algorithms to deal with artifacts generated by lens distortion [LENS_DIST], blur [BLUR], noise [NOISE] etc are also required.
Generation of Images
The AR application must generate a high-quality video that has the properties described in the previous step and overlay the video on the AR device's display- a step called situated visualization. This entails dealing with registration errors that may arise, ensuring that there is no visual interference [VIS_INTERFERE], and finally maintaining temporal coherence by adapting to the movement of user's eyes and head.
Requirements
The components of AR applications perform tasks such as real-time generation and processing of high-quality video content that are computationally intensive. As a result,on AR devices such as AR glasses excessive heat is generated by the chip-sets that are involved in the computation [DEV_HEAT_1], [DEV_HEAT_2]. Additionally, the battery on such devices discharges quickly when running such applications [BATT_DRAIN].
A solution to the heat dissipation and battery drainage problem is to offload the processing and video generation tasks to the remote cloud.However, running such tasks on the cloud is not feasible as the end-to-end delays must be within the order of a few milliseconds. Additionally,such applications require high bandwidth and low jitter to provide a high QoE to the user.In order to achieve such hard timing constraints, computationally intensive tasks can be offloaded to Edge devices.
Another requirement for our use case and similar applications such as 360 degree streaming is that the display on the AR/VR device should synchronize the visual input with the way the user is moving their head. This synchronization is necessary to avoid motion sickness that results from a time-lag between when the user moves their head and when the appropriate video scene is rendered. This time lag is often called "motion-to-photon" delay. Studies have shown [PER_SENSE], [XR], [OCCL_3] that this delay can be at most 20ms and preferably between 7-15ms in order to avoid the motion sickness problem. Out of these 20ms, display techniques including the refresh rate of write displays and pixel switching take 12-13ms [OCCL_3], [CLOUD]. This leaves 7-8ms for the processing of motion sensor inputs, graphic rendering, and RTT between the AR/VR device and the Edge. The use of predictive techniques to mask latencies has been considered as a mitigating strategy to reduce motion sickness [PREDICT]. In addition, Edge Devices that are proximate to the user might be used to offload these computationally intensive tasks. Towards this end, the 3GPP requires and supports an Ultra Reliable Low Latency of 0.1ms to 1ms for communication between an Edge server and User Equipment(UE) [URLLC].
Note that the Edge device providing the computation and storage is itself limited in such resources compared to the Cloud. So, for example, a sudden surge in demand from a large group of tourists can overwhelm that device. This will result in a degraded user experience as their AR device experiences delays in receiving the video frames. In order to deal with this problem, the client AR applications will need to use Adaptive Bit Rate (ABR) algorithms that choose bit-rates policies tailored in a fine-grained manner to the resource demands and playback the videos with appropriate QoE metrics as the user moves around with the group of tourists.
However, heavy-tailed nature of several operational parameters make prediction-based adaptation by ABR algorithms sub-optimal[ABR_2]. This is because with such distributions, law of large numbers works too slowly, the mean of sample does not equal the mean of distribution, and as a result standard deviation and variance are unsuitable as metrics for such operational parameters [HEAVY_TAIL_1], [HEAVY_TAIL_2]. Other subtle issues with these distributions include the "expectation paradox" [HEAVY_TAIL_1] where the longer we have waited for an event the longer we have to wait and the issue of mismatch between the size and count of events [HEAVY_TAIL_1]. This makes designing an algorithm for adaptation error-prone and challenging. Such operational parameters include but are not limited to buffer occupancy, throughput, client-server latency, and variable transmission times.In addition, edge devices and communication links may fail and logical communication relationships between various software components change frequently as the user moves around with their AR device [UBICOMP].
Thus, once the offloaded computationally intensive processing is completed on the Edge Computing, the video is streamed to the user with the help of an ABR algorithm which needs to meet the following requirements [ABR_1]:
- Dynamically changing ABR parameters: The ABR algorithm must be able to dynamically change parameters given the heavy-tailed nature of network throughput. This, for example, may be accomplished by AI/ML processing on the Edge Computing on a per client or global basis.
- Handling conflicting QoE requirements: QoE goals often require high bit-rates, and low frequency of buffer refills. However in practice, this can lead to a conflict between those goals. For example, increasing the bit-rate might result in the need to fill up the buffer more frequently as the buffer capacity might be limited on the AR device. The ABR algorithm must be able to handle this situation.
- Handling side effects of deciding a specific bit rate: For example, selecting a bit rate of a particular value might result in the ABR algorithm not changing to a different rate so as to ensure a non-fluctuating bit-rate and the resultant smoothness of video quality . The ABR algorithm must be able to handle this situation.
AR Network Traffic
Traffic Workload
As discussed earlier, the parameters that capture the characteristics of XR application behavior are heavy-tailed. Examples of such parameters include the distribution of arrival times between XR application invocation, the amount of data transferred, and the inter-arrival times of packets within a session.. As a result, any traffic model based on such parameters are themselves heavy-tailed. Using these models to predict performance under alternative resource allocations by the network operator is challenging.
Traffic Performance Metrics
The performance requirements for AR/VR traffic have characteristics that need to be considered when operationalizing a network. We now discuss these characteristics.
The bandwidth requirements of XR applications are substantially higher than those of video based applications.
The latency requirements of XR applications have been studied recently [AR_TRAFFIC] .The following issues were identified.:
- The uploading of data from an AR device to a remote server for processing dominates the end-to-end latency.
- A lack of visual features in the grid environment can cause increased latencies as the AR device uploads additional visual data for processing to the remote server.
- AR applications tend to have large bursts that are separated by significant time gaps.
The packet loss rates in wireless links between XR devices and the Edge server can be as high as 2% or more [WIRELESS_1]. 5G systems however promise a reliability of 99.999% with an air interface latency of 0.5ms[RELIABILITY_1], [RELIABILITY_2].
Finally, XR applications interact with each other on a time scale of a round-trip-time propagation and this must be considered when operationalizing a network.
Acknowledgements
Many Thanks to Spencer Dawkins, Rohit Abhishek, Jake Holland, Kiran Makhijani and Ali Begen for providing very helpful feedback suggestions and comments.
Informative References
[DEV_HEAT_1]

Draining our Glass: An Energy and Heat characterization of Google Glass
Robert LiKamWa
Zhen Wang
Aaron Carroll
Felix Xiaozhu Lin
Lin Zhong
2013
In Proceedings of 5th Asia-Pacific Workshop on Systems pp. 1-7
[EDGE_1]

The Emergence of Edge Computing
Mahadev Satyanarayanan
2017
In Computer 50(1) pp. 30-39
[EDGE_2]

The Seminal Role of Edge-Native Applications
Mahadev Satyanarayanan
Guenter Klas
Marco Silva
Simone Mangiante
2019
In IEEE International Conference on Edge Computing (EDGE) pp. 33-40
[ABR_1]

Neural Adaptive Video Streaming with Pensieve
Hongzi Mao
Ravi Netravali
Mohammad Alizadeh
2017
In Proceedings of the Conference of the ACM Special Interest Group on Data Communication, pp. 197-210
[ABR_2]

Learning in situ: a randomized experiment in video streaming
Francis Y. Yan
Hudson Ayers
Chenzhi Zhu
Sadjad Fouladi
James Hong
Keyi Zhang
Philip Levis
Keith Winstein
2020
In 17th USENIX Symposium on Networked Systems Design and Implementation (NSDI 20), pp. 495-511
[HEAVY_TAIL_1]

Internet measurement: infrastructure, traffic and applications
Mark Crovella
Balachander Krishnamurthy
2006
John Wiley and Sons Inc.
[HEAVY_TAIL_2]

The Statistical Consequences of Fat Tails
Nassim Nicholas Taleb
2020
STEM Academic Press
[UBICOMP]

Ubiquitous Computing Systems
Jakob Eyvind Bardram
Adrian Friday
2009
In Ubiquitous Computing Fundamentals pp. 37-94. CRC Press
[SLAM_1]

A minimal solution to the generalized pose-and-scale problem
Jonathan Ventura
Clemens Arth
Gerhard Reitmayr
Dieter Schmalstieg
2014
In Proceedings of the IEEE Conference on Computer Vision and Pattern Recognition, pp. 422-429
[SLAM_2]

A scalable solution to the generalized pose and scale problem
Chris Sweeny
Victor Fragoso
Tobias Hollerer
Matthew Turk
2014
In European Conference on Computer Vision, pp. 16-31
[SLAM_3]

Model estimation and selection towards unconstrained real-time tracking and mapping
Steffen Gauglitz
Chris Sweeny
Jonathan Ventura
Matthew Turk
Tobias Hollerer
2013
In IEEE transactions on visualization and computer graphics, 20(6), pp. 825-838
[SLAM_4]

Handling pure camera rotation in keyframe-based SLAM
Christian Pirchheim
Dieter Schmalstieg
Gerhard Reitmayr
2013
In 2013 IEEE international symposium on mixed and augmented reality (ISMAR), pp. 229-238
[OCCL_1]

Interactive Occlusion and automatic object placementfor augmented reality
David E. Breen
Ross T. Whitaker
Mihran Tuceryan
1996
In Computer Graphics Forum, vol. 15, no. 3 , pp. 229-238,Edinburgh, UK: Blackwell Science Ltd
[OCCL_2]

Pixel-wise closed-loop registration in video-based augmented reality
Feng Zheng
Dieter Schmalstieg
Greg Welch
2014
In IEEE International Symposium on Mixed and Augmented Reality (ISMAR), pp. 135-143
[PHOTO_REG]

Online tracking of outdoor lighting variations for augmented reality with moving cameras
Yanli Liu
Xavier Granier
2012
In IEEE Transactions on visualization and computer graphics, 18(4), pp.573-580
[GLB_ILLUM_1]

Differential irradiance caching for fast high-quality light transport between virtual and real worlds.
Peter Kan
Hannes Kaufmann
2013
In IEEE International Symposium on Mixed and Augmented Reality (ISMAR),pp. 133-141
[GLB_ILLUM_2]

Delta voxel cone tracing.
Tobias Franke
2014
In IEEE International Symposium on Mixed and Augmented Reality (ISMAR), pp. 39-44
[LENS_DIST]

Practical calibration procedures for augmented reality.
Anton Fuhrmann
Dieter Schmalstieg
2000
In Virtual Environments 2000, pp. 3-12. Springer, Vienna
[BLUR]

Physically-Based Depth of Field in Augmented Reality.
Peter Kan
Hannes Kaufmann
2012
In Eurographics (Short Papers), pp. 89-92.
[NOISE]

Enhanced visual realism by incorporating camera image effects.
Jan Fischer
Dirk Bartz
Wolfgang Straßer
2006
In IEEE/ACM International Symposium on Mixed and Augmented Reality, pp. 205-208.
[VIS_INTERFERE]

Interactive focus and context visualization for augmented reality.
Denis Kalkofen
Erick Mendez
Dieter Schmalstieg
2007
In 6th IEEE and ACM International Symposium on Mixed and Augmented Reality, pp. 191-201.
[DEV_HEAT_2]

Thermal model and countermeasures for future smart glasses.
Kodai Matsuhashi
Toshiki Kanamoto
Atsushi Kurokawa
2020
In Sensors, 20(5), p.1446.
[BATT_DRAIN]

A survey of wearable devices and challenges.
Suranga Seneviratne
Yining Hu
Tham Nguyen
Guohao Lan
Sara Khalifa
Kanchana Thilakarathna
Mahbub Hassan
Aruna Seneviratne
2017
In IEEE Communication Surveys and Tutorials, 19(4), p.2573-2620.
[PER_SENSE]

Perceptual sensitivity to head tracking latency in virtual environments with varying degrees of scene complexity.
Katrina Mania
Bernard D. Adelstein
Stephen R. Ellis
Michael I. Hill
2004
In Proceedings of the 1st Symposium on Applied perception in graphics and visualization pp. 39-47.
[XR]

3GPP TR 26.928: Extended Reality (XR) in 5G.
3GPP
2020
https://portal.3gpp.org/desktopmodules/Specifications/SpecificationDetails.aspx?specificationId=3534
[CLOUD]

Surrounded by the Clouds: A Comprehensive Cloud Reachability Study.
Lorenzo Corneo
Maximilian Eder
Nitinder Mohan
Aleksandr Zavodovski
Suzan Bayhan
Walter Wong
Per Gunningberg
Jussi Kangasharju
Jörg Ott
2021
In Proceedings of the Web Conference 2021, pp. 295-304
[OCCL_3]

Oculus Shares 5 Key Ingredients for Presence in Virtual Reality.
Ben Lang
2014
https://www.roadtovr.com/oculus-shares-5-key-ingredients-for-presence-in-virtual-reality/
[PREDICT]

The effect of apparent latency on simulator sickness while using a see-through helmet-mounted display: Reducing apparent latency with predictive compensation..
Timothy J. Buker
Dennis A. Vincenzi
John E. Deaton
2012
In Human factors 54.2, pp. 235-249.
[URLLC]

3GPP TR 23.725: Study on enhancement of Ultra-Reliable Low-Latency Communication (URLLC) support in the 5G Core network (5GC).
3GPP
2019
https://portal.3gpp.org/desktopmodules/Specifications/ SpecificationDetails.aspx?specificationId=3453
[AUGMENTED]

Augmented Reality
Dieter Schmalstieg
Dennis A.Hollerer
2016
Addison Wesley
[REG]

Registration error analysis for augmented reality.
Richard L. Holloway
1997
In Presence:Teleoperators and Virtual Environments 6.4, pp. 413-432.
[AR_TRAFFIC]

Characterization of Multi-User Augmented Reality over Cellular Networks
Kittipat Apicharttrisorn
Bharath Balasubramanian
Jiasi Chen
Rajarajan Sivaraj
Yi-Zhen Tsai
Rittwik Jana
Srikanth Krishnamurthy
Tuyen Tran
Yu Zhou
2020
In 17th Annual IEEE International Conference on Sensing, Communication, and Networking (SECON), pp. 1-9. IEEE
[EDGE_3]

5G mobile networks: A systems approach.
Larry Peterson
Oguz Sunay
2020
In Synthesis Lectures on Network Systems.
[AUGMENTED_2]

A Survey of Augmented Reality.
Ronald T. Azuma
1997
Presence:Teleoperators and Virtual Environments 6.4, pp. 355-385.
[WIRELESS_1]

Characterizing user behavior and network performance in a public wireless LAN.
Anand Balachandran
Geoffrey M. Voelker
Paramvir Bahl
P. Venkat Rangan
2002
In Proceedings of the 2002 ACM SIGMETRICS international conference on Measurement and modeling of computer systems, pp. 195-205.
[RELIABILITY_1]

3GPP TR 38.913: Study on Scenarios and Requirements for Next Generation Access Technologies.
3GPP
2018
https://portal.3gpp.org/desktopmodules/Specifications/SpecificationDetails.aspx?specificationId=2996
[RELIABILITY_2]

3GPP TR 22.261: Service Requirements For The 5G System.
3GPP
2019
https://portal.3gpp.org/desktopmodules/Specifications/SpecificationDetails.aspx?specificationId=3107
[RFC2119]